<?php

namespace xenarabia\MYMMSMSG\XF\Pub\Controller;
use XF\Mvc\FormAction;
use XF\Mvc\ParameterBag;
use XF\Mvc\Reply\View;
use XF\Pub\Controller\AbstractController;

use xenarabia\MYMMSMSG\XF\Entity\CatMyMms;
use xenarabia\MYMMSMSG\XF\Entity\MmsMsgs As MmsMsgsEntity;


class Account extends XFCP_Account{

    
    protected function assertCanViewMms()
	{
		if (!in_array(\XF::visitor()->user_group_id, \XF::options()->mms_group)) {
			throw $this->exception($this->noPermission());
		}
	}

    public function actionMmsMessges(ParameterBag $params)
    {
        $this->assertCanViewMms();
        $page = $this->filterPage($params->page);
		$perPage = 20;
        $catid_param = $this->filter('cat_id', 'int');
        $firstCatmms = $this->finder('xenarabia\MYMMSMSG\XF:CatMyMms')->with('CatMsgs')->where('cat_act', 1)->order('cat_id', 'ASC')->fetchOne();
        $cat_id = $catid_param ? $catid_param : $firstCatmms->cat_id;
        $mmsmsgs = $this->finder('xenarabia\MYMMSMSG\XF:MmsMsgs')
        ->where([
            'mms_act' => 1,
            'mms_cat_id' => $cat_id 
        ])
        ->limitByPage($page, $perPage);
        $catmms = $this->finder('xenarabia\MYMMSMSG\XF:CatMyMms')->where('cat_act', 1)->order('cat_id', 'ASC')->fetch();
        // \XF::dump($mmsmsgs->total());
		$viewParams = [
			'mmsmsgs'	=> $mmsmsgs->fetch(), 
            'total' => $mmsmsgs->total(),
            'page' => $page,
            'perPage' => $perPage,
            'catmms' => $catmms,
            'cat_id' => $cat_id
		];
        // \XF::dump();
        $view = $this->view('xenarabia\MYMMSMSG\XF', 'account_mms_messges', $viewParams);
        return $this->addAccountWrapperParams($view, 'mms_messges');
    }


    public function actionChooseMms(ParameterBag $params)
    {
        $mms_id = $this->filter('mms_is', 'int');
        $user_id = \XF::visitor()->user_id;
        $updateUserMms = \XF::db()->update('xf_user', ['user_my_mms' => $mms_id], 'user_id = ?', [$user_id]);

        if ($updateUserMms) {
            return $this->redirect($this->buildLink('account/mms-messges'), \XF::phrase('mms_your_mms_msg_has_been_saved'));
        }else{
            return $this->redirect($this->buildLink('account/mms-messges'), \XF::phrase('mms_error_has_been_occured_while_choose_mms'));
        }
    }

    public function actionMmsSaveChanges(ParameterBag $params)
    {
        $mms_value = $this->filter('mms_no_msg_selected', 'int');
        if ($mms_value == 0) {
            return $this->redirect($this->buildLink('account/mms-messges'));
        }else{
            $user_id = \XF::visitor()->user_id;
            $updateUserMms = \XF::db()->update('xf_user', ['user_my_mms' => 0], 'user_id = ?', [$user_id]);

            if ($updateUserMms) {
                return $this->redirect($this->buildLink('account/mms-messges'), \XF::phrase('your_changes_have_been_saved'));
            }else{
                return $this->redirect($this->buildLink('account/mms-messges'), \XF::phrase('mms_error_has_been_occured_while_choose_mms'));
            }
        }
    }


}